/*
 * fancydbconnectionbinder.h
 *
 *  Created on: 10.03.2010
 *      Author: lech
 */

#ifndef FANCYDBCONNECTIONBINDER_H_
#define FANCYDBCONNECTIONBINDER_H_

#include <fancydb.h>
#include <fancysessioncontextfactory.h>

namespace Fancy {

class String;

namespace DB {

class Connection;
class ConnectionPool;

class FANCYDB_API DBConnectionBinder : public virtual Fancy::SessionContextFactory {

protected:
	//DBConnectionBinder();
    //virtual ~DBConnectionBinder();

public:

    /**
     * Return a new instance with a default specific key: "Fancy::DB::DBConnectionBinder::pooledDBConnection"
     */
    static ptr_t newInstance(const Fancy::ObjPtr<Fancy::DB::ConnectionPool> &dbConnectionPool);

    /**
     * Return a new instance with the specified specific key.
     */
    static ptr_t newInstance(const Fancy::ObjPtr<Fancy::DB::ConnectionPool> &dbConnectionPool, const Fancy::Object::ptr_t &specificKey);

    virtual Fancy::ObjPtr<Fancy::DB::Connection> getConnection() = 0;

    static Fancy::ObjPtr<Fancy::DB::Connection> getConnection_s(const Fancy::Object::ptr_t &specificKey);
    static Fancy::ObjPtr<Fancy::DB::Connection> getConnection_s();
};

}} // end namespaces

#endif /* FANCYDBCONNECTIONBINDER_H_ */
