/*
 * fancydbconnectionbound.h
 *
 *  Created on: 28.11.2009
 *      Author: wglas
 */

#ifndef FANCYDBCONNECTIONBOUND_H_
#define FANCYDBCONNECTIONBOUND_H_

#include <fancydb.h>
#include <fancyobject.h>

namespace Fancy {

namespace DB {

class Connection;

/**
 * This interface is implemented by all spin-offs from a @c Connection
 * like statements or transactions.
 */
class FANCYDB_API ConnectionBound: public virtual Fancy::Object {
public:
	typedef Fancy::ObjPtr<ConnectionBound> ptr;

	/**
	 * Get the underlying connection.
	 */
	virtual Fancy::ObjPtr<Connection> getConnection() const = 0;

protected:
	ConnectionBound();
	virtual ~ConnectionBound();
};

}

}

#endif /* FANCYDBCONNECTIONBOUND_H_ */
