// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancydbexception.h 868 2011-01-26 19:51:33Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Base functionality for OpenSSL integration.
** 
*****************************************************************************/

#ifndef FANCYDB_EXCEPTION_H
#define FANCYDB_EXCEPTION_H

#include <fancydb.h>
#include <fancyexception.h>

extern "C" {
  typedef struct st_mysql MYSQL;
}

namespace Fancy {
  namespace DB {

    class FANCYDB_API Exception : public Fancy::Exception
    {
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
;

      ~Exception() throw();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority ) throw();
    };

    class FANCYDB_API DBException : public Exception
    {
    public:
      DBException (int _err,
    		       const char *strerr,
                   int facility,
                   int priority,
                   const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,6,7)))
#endif
        ;
      ~DBException() throw();

      int getErrno() const throw();
      virtual bool isServerGone() const throw() = 0;
    
    protected:
      DBException (int _err,
    		       int facility,
                   int priority) throw();

      void appendDBError(const char *strerr) throw();

    private:
      unsigned err;
    };
  }
}

#endif
