// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancydblog.h 868 2011-01-26 19:51:33Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
** 
*****************************************************************************/

#ifndef FANCYDB_LOG_H
#define FANCYDB_LOG_H

#include <fancydb.h>
#include <fancylog.h>

// facility masks:
// facility "fancydbdriver"
#define  FANCYDB_LOG_DRIVER    (1<<0)
// facility "fancydbgeneric"
#define  FANCYDB_LOG_GENERIC   (1<<1)
// facility "fancydbmysql"
#define  FANCYDB_LOG_MYSQL     (1<<2)

namespace Fancy {
  namespace DB {

    extern FANCYDB_API fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    void FANCYDB_API fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));
    
#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
  }
}

#endif // ! FANCYDB_LOG_H
